mysite/mysite/urls.py
from django.contrib import admin
from django.urls import include, path

urlpatterns = [
    path('', include('repeater.urls')),
    path('admin/', admin.site.urls),
]

mysite/repeater/urls.py
from django.urls import path

from . import views

app_name = 'repeater'
urlpatterns = [
        path('', views.index, name='index'),
	path('map/', views.map, name='map'),
        path('qso/', views.qso, name='qso')
]

mysite/repeater/models.py
from django.db import models
import arrow
from geopy import distance
import re

# Create your models here.
class Qso(models.Model):
    callsign = models.CharField(max_length=8)
    longitude = models.DecimalField(max_digits=9, decimal_places=6)
    latitude = models.DecimalField(max_digits=8, decimal_places=6)
    signal_strength = models.IntegerField(null=True)
    created_date = models.DateTimeField('date created')
    verified = models.BooleanField(default=False)

    def __str__(self):
        string = f'{self.callsign}'
        if not self.verified:
            string += " UNVERIFIED"
        return string

    def escaped_callsign(self):
        return re.sub('[^A-Za-z0-9 ]+', '', self.callsign)

    def return_color(self):
        if not self.signal_strength:
            return 'blue'
        if self.signal_strength >= 8:
            return 'green'
        elif self.signal_strength < 8 and self.signal_strength >= 5:
            return 'orange'
        else:
            return 'red'

    def return_human_date(self):
        friendly_date = arrow.get(self.created_date)
        return friendly_date.humanize()

    def return_distance_to_repeater(self):
        repeater_coords = (53.332787, -3.853334)
        return int(distance.distance(repeater_coords, (self.latitude, self.longitude)).miles)

class SiteContent(models.Model):
    front_page_intro = models.TextField()
    

mysite/repeater/views.py
from django.shortcuts import render
from django.http import HttpResponseRedirect
from django.template import loader
from django.urls import reverse
from django.conf import settings
from django.contrib import messages

from .models import Qso, SiteContent
from django.utils import timezone

import logging
import what3words

def index(request):
    site_content = SiteContent.objects.first()
    context = {
        'front_page_intro': site_content.front_page_intro,
    }
    return render(request, 'repeater/index.html', context)

def map(request):
    qso_list = Qso.objects.all().filter(verified=True)
    context = {'qso_list': qso_list}
    return render(request, 'repeater/map.html', context)

def qso(request):
    if request.method == 'POST':
        logging.info(f"QSO being sent: {request.POST}")
        callsign =  request.POST['callsign'].upper()
        if len(callsign) > 8:
             messages.error(request, "Callsign can only be 8 characters long. For mobile/portable just add /m or /p")
             return render(request, 'repeater/qso.html')
        signal_strength = request.POST['signal_strength']
        try:
            int(signal_strength)
        except ValueError:
            messages.error(request, "Your signal strenth should be a number between 1 and 9")
            return render(request, 'repeater/qso.html')
        longitude = request.POST['longitude']
        latitude = request.POST['latitude']
        if longitude and latitude:
            try:
                float(longitude)
                float(latitude)
            except:
                messages.error(request, "Your longitude and latitude should be in decimal format")
                return render(request, 'repeater/qso.html')
        if 'what3words' in request.POST and request.POST['what3words']:
            if settings.WHAT3WORDS_KEY:
                geocoder = what3words.Geocoder(settings.WHAT3WORDS_KEY)
                coords = geocoder.convert_to_coordinates(request.POST['what3words'])
                print(coords)
                if 'square' in coords:
                    longitude = coords['square']['southwest']['lng']
                    latitude = coords['square']['southwest']['lat']
                else:
                    messages.error(request, "Your What3Words reference was incorrect")
                    return render(request, 'repeater/qso.html')
            else:
                messages.error(request, "What3Words is not set up on this server, please enter latitude and longitude")
                return render(request, 'repeater/qso.html')
        qso = Qso(
            callsign=callsign,
            signal_strength=signal_strength,
            verified=False, 
            longitude=longitude,
            latitude=latitude,
            created_date=timezone.now()
        )
        try:
            qso.save()
        except Exception as e:
            logging.error(f"QSO unable to be saved - callsign: {callsign} signal: {signal_strength} long: {longitude} lat: {latitude}")
            messages.error(request, f"Something went wrong, please email {settings.ADMIN_EMAIL}")
            return render(request, 'repeater/qso.html')
        logging.info(f"QSO added to database {qso}")
        messages.success(request, "Your QSO has been added! We'll verify it and then add it to the map")
        return HttpResponseRedirect(reverse('repeater:index'))
    return render(request, 'repeater/qso.html')

mysite/repeater/templates/repeater/base.html
<!doctype html>
<html lang="en">
  <head>
    <!-- Required meta tags -->
    <meta charset="utf-8">
    <meta name="viewport" content="width=device-width, initial-scale=1">

    <!-- Bootstrap CSS -->
    <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/4.0.0/css/bootstrap.min.css" integrity="sha384-Gn5384xqQ1aoWXA+058RXPxPg6fy4IWvTNh0E263XmFcJlSAwiGgFAW/dAiS6JXm" crossorigin="anonymous">
    <title>{{ repeater_name }}</title>

    <!-- Mapbox -->
    <link href="https://api.mapbox.com/mapbox-gl-js/v2.1.1/mapbox-gl.css" rel="stylesheet">
		<script src="https://api.mapbox.com/mapbox-gl-js/v2.1.1/mapbox-gl.js"></script>

    <!-- Font Awesome -->
    <script src="https://kit.fontawesome.com/1b4e588f55.js" crossorigin="anonymous"></script>
    
  </head>
  <body>
	  <div class="container">
    {% block content %}
    {% endblock %}
	  </div>
    <br><br><br><br><br><br>
    <!-- Optional JavaScript; choose one of the two! -->

    <!-- Option 1: Bootstrap Bundle with Popper -->
    <script src="https://cdn.jsdelivr.net/npm/bootstrap@5.0.0-beta2/dist/js/bootstrap.bundle.min.js" integrity="sha384-b5kHyXgcpbZJO/tY9Ul7kGkf1S0CWuKcCD38l8YkeH8z8QjE0GmW1gYU5S9FOnJ0" crossorigin="anonymous"></script>
	</body>
</html>

mysite/repeater/templates/repeater/index.html
{% extends 'repeater/base.html' %}
{% block content %}
<div class="jumbotron" style="background-color: #edfcf5; margin-top: 1em; padding-top: 2em; padding-bottom: 2em;">
    <h1 class="display-4">Welcome to {{ repeater_name }}</h1>
    <p>
        <strong><i class="fas fa-broadcast-tower"></i> Transmit: </strong>{{ repeater_tx_freq }} mhz<br>
        <strong>Receive: </strong>{{ repeater_rx_freq }} mhz<br>
        <strong>Shift: </strong> {{ repeater_shift }} mhz<br>
        <strong>Tone: </strong>{{ repeater_tone }} mhz
    </p>
</div>
<div class="container">
    <div class="row">
        <div class="col-sm-5">
            {{ front_page_intro|safe }}
        </div>
        <div class="col-sm">
            <div id="map" style="height: 500px;"></div>
        </div>
        
    </div>
    <div class="row">
        <div class="col">
            <h1 class="text-center" style="margin-top: 2em;"><a href="map" style="color: #99eec6;"><i class="fas fa-map-marked-alt"></i></a></h1>
            <h2 class="text-center">Browse our QSO map</h2>
        </div>
        <div class="col">
            <h1 class="text-center" style="margin-top: 2em;"><a href="qso" style="color: #913347;"><i class="fas fa-map-marked-alt"></i></a></h1>
            <h2 class="text-center">Add a QSO</h2>
        </div>
    </div>
</div>
<script>
    mapboxgl.accessToken = '{{ mapbox_token }}';
    var map = new mapboxgl.Map({
        container: 'map', // container id
        style: 'mapbox://styles/mapbox/satellite-streets-v11', // style URL
        center: [{{ repeater_long }}, {{ repeater_lat }}], // starting position [lng, lat]
        zoom: 8 // starting zoom
    });
    var popupRepeater = new mapboxgl.Popup({offset: 5}).setHTML(
        "<h3>{{ repeater_name }} Repeater</h3><p>TX: {{ repeater_tx_freq }}mhz<br>RX: {{ repeater_rx_freq }}mhz<br>Split: {{ repeater_shift }}mhz<br>Tone: {{ repeater_tone }}hz</p>"
    );
    var markerRepeater = new mapboxgl.Marker()
        .setLngLat([{{ repeater_long }}, {{ repeater_lat }}])
        .setPopup(popupRepeater)
        .addTo(map)
        .togglePopup();
</script> 
{% endblock %}

mysite/repeater/templates/repeater/map.html
{% load static %}
<!DOCTYPE html>
<html>
	<head>
		<meta charset="utf-8">
		<title>{{ repeater_name }} Repeater Map</title>
		<meta name="viewport" content="initial-scale=1,maximum-scale=1,user-scalable=no">
		<link rel="stylesheet" href="https://unpkg.com/leaflet@1.7.1/dist/leaflet.css"
			integrity="sha512-xodZBNTC5n17Xt2atTPuE1HxjVMSvLVW9ocqUKLsCC5CXdbqCmblAshOMAS6/keqq/sMZMZ19scR4PsZChSR7A=="
			crossorigin=""/>
		<!-- Make sure you put this AFTER Leaflet's CSS -->
 		<script src="https://unpkg.com/leaflet@1.7.1/dist/leaflet.js"
 			integrity="sha512-XQoYMqMTK8LvdxXYG3nZ448hOEQiglfqkJs1NOQV44cWnUrBc8PkAOcXy20w0vlaXaVUearIOBhiXZ5V3ynxwA=="
 			crossorigin=""></script>
		<script src="{% static 'repeater/js/leaflet-heat.js' %}"></script>
		<style>
			body { margin: 0; padding: 0; }
			#map { position: absolute; top: 0; bottom: 0; width: 100%; }
		</style>
	</head>
	<body>
		<div id="map"></div>
		<script>
			var mymap = L.map('map').setView([{{ repeater_lat }}, {{ repeater_long }}], 9);
			L.tileLayer('https://api.mapbox.com/styles/v1/{id}/tiles/{z}/{x}/{y}?access_token={{ mapbox_token }}', {
    			attribution: 'Map data &copy; <a href="https://www.openstreetmap.org/copyright">OpenStreetMap</a> contributors, Imagery © <a href="https://www.mapbox.com/">Mapbox</a>',
    			maxZoom: 13,
    			id: 'mapbox/navigation-preview-night-v4',
    			tileSize: 512,
    			zoomOffset: -1,
    			accessToken: '{{ mapbox_token }}'
			}).addTo(mymap);
				
			var markerRepeater = L.marker([{{ repeater_lat }}, {{ repeater_long }}]).addTo(mymap);
			markerRepeater.bindPopup("<h1>{{ repeater_name }} Repeater</h1><p>TX: {{ repeater_tx_freq }}mhz<br>RX: {{ repeater_rx_freq }}mhz<br>Split: {{ repeater_shift }}mhz<br>Tone: {{ repeater_tone }}hz</p>").openPopup();

			{% for qso in qso_list %}
			var marker{{ qso.id }} = L.marker([{{ qso.latitude }}, {{ qso.longitude }}]).addTo(mymap);
			marker{{ qso.id }}.bindPopup("<h1>{{ qso.callsign }}</h1><p>{% if qso.signal_strength %}Signal strength: S{{ qso.signal_strength }}{% else %}No signal strength{% endif %}<br>Recorded: {{ qso.return_human_date }}<br>Distance: {{ qso.return_distance_to_repeater }} miles</p>");
			{% endfor %}
			var heat = L.heatLayer(
				[
					{% for qso in qso_list %}
					[{{ qso.latitude }}, {{ qso.longitude }}, {{ qso.signal_strenth }}],
					{% endfor %}
				], {radius: 100}).addTo(mymap);
		</script> 
	</body>
</html>

mysite/repeater/templates/repeater/qso.html
{% extends 'repeater/base.html' %}
{% block content %}
<h4>Help update our QSO Map</h4>
<p>By filling in the form below, you help fill in our QSO map. You can use latitude/longitude OR What3Words, and by entering your 
	signal strength (just the strength, not the readability) you help us improve the repeater.</p>
</p>
<form action="{% url 'repeater:qso' %}" method="post">
	{% if messages %}
    {% for message in messages %}
        {% if message.level == DEFAULT_MESSAGE_LEVELS.ERROR %}
		<div class="alert alert-danger" role="alert">
		{% else %}
		<div class="alert alert-primary" role="alert">

		{% endif %}
		{{ message }}
		</div>
    {% endfor %}
{% endif %}
	<div class="mb-3">
		{% csrf_token %}
    		<label for="callsign"class="form-label" >Callsign: </label>
    		<input id="callsign" type="text" name="callsign" class="form-control" aria-describedby="callsignHelp" placeholder="2W0AMN">
			<small id="callsignHelpBlock" class="form-text text-muted">
				The callsign can be up to 8 characters. For mobile or portable operation, add "/m" or "/p"
			</small>
	</div>
	<div class="mb-3">
    		<label for="signal_strength" class="form-label">Signal Strength: </label>
    		<input id="signal_strength" type="number" name="signal_strength" class="form-control" aria-describedby="signalHelp" placeholder="9">
	</div>
	<br><br>
	<h4>Add the Latitude and Longitude OR the What3Words reference, you don't need to enter both</h4>
	<div class="mb-3">
    		<label for="longitude" class="form-label">Longitude: </label>
    		<input id="longitude" type="longitude" name="longitude" class="form-control" placeholder="-3.799090">
	</div>
	<div class="mb-3">
    		<label for="latitude" class="form-label">Latitude: </label>
    		<input id="latitude" type="text" name="latitude" class="form-control" placeholder="53.141060">
	</div>
	<div class="mb-3">
    		<label for="what3words" class="form-label">What3Words: </label>
		<input id="what3words" type="text" name="what3words" class="form-control" aria-describedby="whatHelp", placeholder="belts.thumb.woodstove">
	</div>
    	<button type="submit" class="btn btn-primary">Enter QSO</button>
</form>
{% endblock %}